// ============================================================================
// File: binaryTree.h
// Author: Jay Oblay (Frenchman extraordinaire)
// Last Modified:  Fall 2020
// Description: 
// This file describes a "binary tree" and the related data nodes
//
// Notice however, the "tree" is implied
// All that is defined is a binary tree node typ: btNode
// The "tree" must be maintained in the main program via pointers or similar
// A better option would be to make a tree class that uses the btNode
// and has the below 'global functions' as member functions...
// So this is mostly transitional code, but can work for now.
// 
// For example:
//    Notice the use of the word Item instead of just a capital T
//    for the type of the class
//
// Tasks: find TODOs, clean up this code
// ============================================================================

#pragma once

#include <cstdlib>

// ----------------------------------------------------------------------------
// --------------------------------------------- begin btNode
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Declare and define the node type of our binary tree
// ----------------------------------------------------------------------------
template <typename Item>
class btNode
{
	public:
	   Item m_data;
	   btNode *mp_left;
	   btNode *mp_right;
	   
	   // constructor declared and defined (not good programming practice, but works)
	   btNode() { mp_left = NULL; mp_right = NULL; };  

};

// ----------------------------------------------------------------------------
// --------------------------------------------- end btNode
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
// - Templated GLOBAL function Prototype (declarations)
// - to work with the above btNode
// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
template <class Item>
btNode<Item>* createNode( const Item& entry,
                          btNode<Item>* leftPtr = NULL,
                          btNode<Item>* rightPtr = NULL )
{
	btNode<Item> *resultPtr = new btNode<Item>;
	
	// TODO: set the resultPtr's m_data = entry, and its pointers as needed
	XXXXX      = XXXXXX;
	XXXXXX     = XXXXXX;
	resultPtr->mp_right    = rightPtr;

	return resultPtr;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
template <class Item>
bool isLeaf(const btNode<Item>& node)
{
	// TODO: if both pointers are NULL return true
	return (node.mp_left == XXXXXX) && (node.mp_right == NULL);
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
template <class Item>
void treeClear(btNode<Item>*& rootPtr)
{
	if (rootPtr != NULL)
	{
		treeClear(rootPtr->mp_left);
		treeClear(rootPtr->mp_right);
		delete rootPtr;
		rootPtr = NULL;
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
template <class Item>
btNode<Item>* treeCopy(btNode<Item>* rootPtr)
{
	btNode<Item> *leftPtr;
	btNode<Item> *rightPtr;
	if (rootPtr == NULL)
		return NULL;
	else
	{
		leftPtr = treeCopy(rootPtr->mp_left);
		rightPtr = treeCopy(rootPtr->mp_right);
		return create_node(rootPtr->m_data, leftPtr, rightPtr);
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// end file
